Merge "Pass the DOCKER_* env vars when running docker"
[apex-tripleo-heat-templates.git] / extraconfig / tasks / yum_update.sh
1 #!/bin/bash
2
3 # A heat-config-script which runs yum update during a stack-update.
4 # Inputs:
5 #   deploy_action - yum will only be run if this is UPDATE
6 #   update_identifier - yum will only run for previously unused values of update_identifier
7 #   command - yum sub-command to run, defaults to "update"
8 #   command_arguments - yum command arguments, defaults to ""
9
10 echo "Started yum_update.sh on server $deploy_server_id at `date`"
11 echo -n "false" > $heat_outputs_path.update_managed_packages
12
13 if [ -f /.dockerenv ]; then
14     echo "Not running due to running inside a container"
15     exit 0
16 fi
17
18 if [[ -z "$update_identifier" ]]; then
19     echo "Not running due to unset update_identifier"
20     exit 0
21 fi
22
23 timestamp_dir=/var/lib/overcloud-yum-update
24 mkdir -p $timestamp_dir
25
26 # sanitise to remove unusual characters
27 update_identifier=${update_identifier//[^a-zA-Z0-9-_]/}
28
29 # seconds to wait for this node to rejoin the cluster after update
30 cluster_start_timeout=600
31 galera_sync_timeout=1800
32 cluster_settle_timeout=1800
33
34 timestamp_file="$timestamp_dir/$update_identifier"
35 if [[ -a "$timestamp_file" ]]; then
36     echo "Not running for already-run timestamp \"$update_identifier\""
37     exit 0
38 fi
39 touch "$timestamp_file"
40
41 command_arguments=${command_arguments:-}
42
43 list_updates=$(yum list updates)
44
45 if [[ "$list_updates" == "" ]]; then
46     echo "No packages require updating"
47     exit 0
48 fi
49
50 pacemaker_status=""
51 if hiera -c /etc/puppet/hiera.yaml service_names | grep -q pacemaker; then
52     pacemaker_status=$(systemctl is-active pacemaker)
53 fi
54
55 # Fix the redis/rabbit resource start/stop timeouts. See https://bugs.launchpad.net/tripleo/+bug/1633455
56 # and https://bugs.launchpad.net/tripleo/+bug/1634851
57 if [[ "$pacemaker_status" == "active" && \
58       "$(hiera -c /etc/puppet/hiera.yaml bootstrap_nodeid)" = "$(facter hostname)" ]] ; then
59     if pcs resource show rabbitmq | grep -E "start.*timeout=100"; then
60         pcs resource update rabbitmq op start timeout=200s
61     fi
62     if pcs resource show rabbitmq | grep -E "stop.*timeout=90"; then
63         pcs resource update rabbitmq op stop timeout=200s
64     fi
65     if pcs resource show redis | grep -E "start.*timeout=120"; then
66         pcs resource update redis op start timeout=200s
67     fi
68     if pcs resource show redis | grep -E "stop.*timeout=120"; then
69         pcs resource update redis op stop timeout=200s
70     fi
71 fi
72
73 if [[ "$pacemaker_status" == "active" ]] ; then
74     echo "Pacemaker running, stopping cluster node and doing full package update"
75     node_count=$(pcs status xml | grep -o "<nodes_configured.*/>" | grep -o 'number="[0-9]*"' | grep -o "[0-9]*")
76     if [[ "$node_count" == "1" ]] ; then
77         echo "Active node count is 1, stopping node with --force"
78         pcs cluster stop --force
79     else
80         pcs cluster stop
81     fi
82 else
83     echo "Upgrading openstack-puppet-modules and its dependencies"
84     yum -q -y update openstack-puppet-modules
85     yum deplist openstack-puppet-modules | awk '/dependency/{print $2}' | xargs yum -q -y update
86     echo "Upgrading other packages is handled by config management tooling"
87     echo -n "true" > $heat_outputs_path.update_managed_packages
88     exit 0
89 fi
90
91 command=${command:-update}
92 full_command="yum -q -y $command $command_arguments"
93 echo "Running: $full_command"
94
95 result=$($full_command)
96 return_code=$?
97 echo "$result"
98 echo "yum return code: $return_code"
99
100 # Writes any changes caused by alterations to os-net-config and bounces the
101 # interfaces *before* restarting the cluster.
102 os-net-config -c /etc/os-net-config/config.json -v --detailed-exit-codes
103 RETVAL=$?
104 if [[ $RETVAL == 2 ]]; then
105     echo "os-net-config: interface configuration files updated successfully"
106 elif [[ $RETVAL != 0 ]]; then
107     echo "ERROR: os-net-config configuration failed"
108     exit $RETVAL
109 fi
110
111 if [[ "$pacemaker_status" == "active" ]] ; then
112     echo "Starting cluster node"
113     pcs cluster start
114
115     hostname=$(hostname -s)
116     tstart=$(date +%s)
117     while [[ "$(pcs status | grep "^Online" | grep -F -o $hostname)" == "" ]]; do
118         sleep 5
119         tnow=$(date +%s)
120         if (( tnow-tstart > cluster_start_timeout )) ; then
121             echo "ERROR $hostname failed to join cluster in $cluster_start_timeout seconds"
122             pcs status
123             exit 1
124         fi
125     done
126
127     tstart=$(date +%s)
128     while ! clustercheck; do
129         sleep 5
130         tnow=$(date +%s)
131         if (( tnow-tstart > galera_sync_timeout )) ; then
132             echo "ERROR galera sync timed out"
133             exit 1
134         fi
135     done
136
137     echo "Waiting for pacemaker cluster to settle"
138     if ! timeout -k 10 $cluster_settle_timeout crm_resource --wait; then
139         echo "ERROR timed out while waiting for the cluster to settle"
140         exit 1
141     fi
142
143     pcs status
144 fi
145
146 echo "Finished yum_update.sh on server $deploy_server_id at `date`"
147
148 exit $return_code